module VectorClock where

import Data.List (nub)
import Data.Maybe (fromMaybe)

newtype VectorClock = VectorClock [Int] deriving (Show,Eq)

instance Ord VectorClock where
  compare (VectorClock a) (VectorClock b) = 
    case nub $ filter (/= EQ) $ zipWith (compare) a b of
      [o] -> o
      _ -> EQ

merge :: VectorClock -> VectorClock -> VectorClock
merge (VectorClock a) (VectorClock b) = VectorClock $ zipWith max a b

inc :: Int -> VectorClock -> VectorClock
inc id (VectorClock t) = VectorClock $ zipWith (\e i -> if i == id then e + 1 else e) t [0..]

size :: VectorClock -> Int
size (VectorClock t) = length t